<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-icon-button
        v-bind="props"
        icon="custom:mingcute:more-2-line"
        variant="text"
        color="onSurfaceVariant"
      />
    </template>

    <template #default>
      <div class="w-fit flex items-center rounded-[8px] p-2 bg-surface cardShadow">
        <svn-pro-icon-button
          icon="custom:mingcute:align-left-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignLeft ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignLeft"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-center-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignCenter ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignCenter"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-right-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignRight ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignRight"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-justify-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignJustify ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignJustify"
        />
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative items-center justify-center translate-y-0.5">
    <PopoverButton>
      <svn-pro-icon-button
        icon="custom:mingcute:more-2-line"
        variant="text"
        color="onSurfaceVariant"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10">
      <div class="w-fit flex items-center rounded-[8px] p-2 bg-surface cardShadow">
        <svn-pro-icon-button
          icon="custom:mingcute:align-left-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignLeft ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignLeft"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-center-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignCenter ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignCenter"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-right-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignRight ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignRight"
        />

        <svn-pro-icon-button
          icon="custom:mingcute:align-justify-line"
          variant="text"
          :color="textStates(editorRef)?.isAlignJustify ? 'primary' : 'onSurfaceVariant'"
          @click="textMenuCommands(editorRef).onAlignJustify"
        />
      </div>
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import { Editor } from '@tiptap/vue-3';
import { watch, ref, onMounted } from 'vue';
import SvnProIconButton from '../../button/SvnProIconButton.vue';
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue';
import { useTextStates as textStates } from '../hooks/useTextStates.js';
import { useTextMenuCommands as textMenuCommands } from '../hooks/useTextMenuCommands.js';

const props = defineProps({
  size: { type: String, default: null },
  editor: { type: Editor, default: null },
})

onMounted(() => {
  editorRef.value = props.editor
});

const dialog = ref(false);
const editorRef = ref(null);

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
});
</script>

<style lang="scss">
.cardShadow {
  box-shadow: 0px 8px 10px 0px rgba(0, 0, 0, 0.14), 0px 3px 14px 0px rgba(0, 0, 0, 0.12), 0px 5px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>